#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon May 13 07:50:55 2019

@author: fuaa
"""
from matplotlib import pyplot as plt
import numpy as np
import getpass
import socket
from matplotlib.colors import LinearSegmentedColormap
from __kmeans__ import *

_THRESHOLD = 10e-9


#########################################################################
def validar_resultado(*args, **kwargs):
    """"
    Función para validar resultado a invocar desde el notebook.
    """
    # _ES_CORRECTO = False
    _DEBUG = False

    # Abrir el cartel del validación.
    print("+-------------------------------------------------------------------------+")
    print("|               FuAA (2do. parcial 2022): validar resultado               |")
    print("+-------------------------------------------------------------------------+")
    for key, value in kwargs.items():
        if key == "debug":
            _DEBUG = value
    if _DEBUG:
        print('args:', args)
        print('kwargs:', kwargs)

    if (len(args) == 0):
        print("| Sin opciones para evaluar.                                              |")
        print("+-------------------------------------------------------------------------+")
        return False

    ###########################################################
    # Ejercicio 1. K-Means Inicialización Aleatoria.
    ###########################################################
    elif (args[0] == "k_means_aleatoria"):
        if 'funcion' in kwargs:
            test_algoritmo = kwargs['funcion']
        else:
            print( "[validar_resultado] Error: llamada sin argumentos (%s)" % args[0] )
            return
        
        X = np.ones((10,4))
        X[:,1] = np.arange(10)
        X[:,2] = np.linspace(-5,5,10)
        X[:,3] = np.linspace(-4,-100,10)
        
        centros_true = np.array([[1.00000000e+00, 8.00000000e+00, 3.88888889e+00, -8.93333333e+01],
                                [1.00000000e+00, 1.00000000e+00, -3.88888889e+00, -1.46666667e+01],
                                [1.00000000e+00, 4.50000000e+00, 1.11022302e-16, -5.20000000e+01]])
        etiquetas_true = np.array([1, 1, 1, 2, 2, 2, 2, 0, 0, 0])
        distancias_true = np.array([[86.16722186, 10.77090273, 48.4690623 ],
                                    [75.39631913,  0.        , 37.69815956],
                                    [64.6254164 , 10.77090273, 26.92725683],
                                    [53.85451366, 21.54180547, 16.1563541 ],
                                    [43.08361093, 32.3127082 ,  5.38545137],
                                    [32.3127082 , 43.08361093,  5.38545137],
                                    [21.54180547, 53.85451366, 16.1563541 ],
                                    [10.77090273, 64.6254164 , 26.92725683],
                                    [ 0.        , 75.39631913, 37.69815956],
                                    [10.77090273, 86.16722186, 48.4690623 ]])
       
        centros, etiquetas, distancias= test_algoritmo( X=X, k=3, init='random', semilla=42)
        
        # Validar dimensión de datos transformados.
        condicion1 = centros.shape == centros_true.shape
        fuaa_assert(condicion1,
                    mensajeFalse="(Init = Random)La dimensión de los centros no es correcta.",
                    mensajeTrue="(Init = Random)Dimensión de centros: resultado validado.")

        # Validar transformación.
        condicion2 = son_iguales(centros_true, centros)
        fuaa_assert(condicion2,
                    mensajeFalse="(Init = Random)El resultado de los centros no es válido.",
                    mensajeTrue="(Init = Random)Centros: resultado validado.")
        
        # Validar dimensión de datos transformados.
        condicion3 = etiquetas.shape == etiquetas_true.shape
        fuaa_assert(condicion3,
                    mensajeFalse="(Init = Random)La dimensión de las etiquetas no es correcta.",
                    mensajeTrue="(Init = Random)Dimensión de las etiquetas: resultado validado.")

        # Validar transformación.
        condicion4 = son_iguales(etiquetas_true, etiquetas)
        fuaa_assert(condicion4,
                    mensajeFalse="(Init = Random)El resultado de las etiquetas no es válido.",
                    mensajeTrue="(Init = Random)Etiquetas: resultado validado.")
        
        # Validar dimensión de datos transformados.
        condicion5 = distancias.shape == distancias_true.shape
        fuaa_assert(condicion5,
                    mensajeFalse="(Init = Random)La dimensión de las distancias no es correcta.",
                    mensajeTrue="(Init = Random)Dimensión de las distancias: resultado validado.")

        # Validar transformación.
        condicion6 = son_iguales(distancias_true, distancias)
        fuaa_assert(condicion6,
                    mensajeFalse="(Init = Random)El resultado de las distancias no es válido.",
                    mensajeTrue="(Init = Random)Distancias: resultado validado.")
        
    ###########################################################
    # Ejercicio 1. K-Means Inicialización ++.
    ###########################################################
    elif (args[0] == "k_means_masmas"):
        if 'funcion' in kwargs:
            test_algoritmo = kwargs['funcion']
        else:
            print( "[validar_resultado] Error: llamada sin argumentos (%s)" % args[0] )
            return
        
        X = np.ones((10,4))
        X[:,1] = np.arange(10)
        X[:,2] = np.linspace(-5,5,10)
        X[:,3] = np.linspace(-4,-100,10)
        
        centros_true = np.array([[1.00000000e+00,  4.50000000e+00,  1.11022302e-16, -5.20000000e+01],
                                [1.00000000e+00,  1.00000000e+00, -3.88888889e+00, -1.46666667e+01],
                                [1.00000000e+00,  8.00000000e+00,  3.88888889e+00, -8.93333333e+01]])
        etiquetas_true = np.array([1, 1, 1, 0, 0, 0, 0, 2, 2, 2])
        distancias_true = np.array([[48.4690623 , 10.77090273, 86.16722186],
                                    [37.69815956,  0.        , 75.39631913],
                                    [26.92725683, 10.77090273, 64.6254164 ],
                                    [16.1563541 , 21.54180547, 53.85451366],
                                    [ 5.38545137, 32.3127082 , 43.08361093],
                                    [ 5.38545137, 43.08361093, 32.3127082 ],
                                    [16.1563541 , 53.85451366, 21.54180547],
                                    [26.92725683, 64.6254164 , 10.77090273],
                                    [37.69815956, 75.39631913,  0.        ],
                                    [48.4690623 , 86.16722186, 10.77090273]])
       
        centros, etiquetas, distancias= test_algoritmo( X=X, k=3, init='masmas', semilla=3)
        
        # Validar dimensión de datos transformados.
        condicion1 = centros.shape == centros_true.shape
        fuaa_assert(condicion1,
                    mensajeFalse="(Init = MasMas)La dimensión de los centros no es correcta.",
                    mensajeTrue="(Init = MasMas)Dimensión de centros: resultado validado.")

        # Validar transformación.
        condicion2 = son_iguales(centros_true, centros)
        fuaa_assert(condicion2,
                    mensajeFalse="(Init = MasMas)El resultado de los centros no es válido.",
                    mensajeTrue="(Init = MasMas)Centros: resultado validado.")
        
        # Validar dimensión de datos transformados.
        condicion3 = etiquetas.shape == etiquetas_true.shape
        fuaa_assert(condicion3,
                    mensajeFalse="(Init = MasMas)La dimensión de las etiquetas no es correcta.",
                    mensajeTrue="(Init = MasMas)Dimensión de las etiquetas: resultado validado.")

        # Validar transformación.
        condicion4 = son_iguales(etiquetas_true, etiquetas)
        fuaa_assert(condicion4,
                    mensajeFalse="(Init = MasMas)El resultado de las etiquetas no es válido.",
                    mensajeTrue="(Init = MasMas)Etiquetas: resultado validado.")
        
        # Validar dimensión de datos transformados.
        condicion5 = distancias.shape == distancias_true.shape
        fuaa_assert(condicion5,
                    mensajeFalse="(Init = MasMas)La dimensión de las distancias no es correcta.",
                    mensajeTrue="(Init = MasMas)Dimensión de las distancias: resultado validado.")

        # Validar transformación.
        condicion6 = son_iguales(distancias_true, distancias)
        fuaa_assert(condicion6,
                    mensajeFalse="(Init = MasMas)El resultado de las distancias no es válido.",
                    mensajeTrue="(Init = MasMas)Distancias: resultado validado.")
        
    ###########################################################
    # Ejercicio 1. Inicialización Aleatoria.
    ###########################################################
    elif (args[0] == "inicializacion_aleatoria"):
        if 'funcion' in kwargs:
            test_algoritmo = kwargs['funcion']
        else:
            print("[validar_resultado] Error: llamada sin argumentos (%s)" % args[0])
            return

        pts = np.vstack((np.ones(50),np.arange(50))).T
        centros_true = np.array([[1,13], [1,39], [1,30], [1,45], [1,17]])
        centros = test_algoritmo(X=pts, k=5, semilla=42)

        # Validar dimensión de datos transformados.
        condicion1 = centros.shape == centros_true.shape
        fuaa_assert(condicion1,
                    mensajeFalse="La dimensión de los centros no es correcta.",
                    mensajeTrue="Dimensión de centros: resultado validado.")

        # Validar transformación.
        condicion2 = son_iguales(centros_true, centros)
        fuaa_assert(condicion2,
                    mensajeFalse="La incialización implementada no es correcta.",
                    mensajeTrue="Inicialización aleatoria: resultado validado.")
    
    ###########################################################
    # Ejercicio 1. Inicialización ++.
    ###########################################################
    elif (args[0] == "inicializacion_masmas"):
        if 'funcion' in kwargs:
            test_algoritmo = kwargs['funcion']
        else:
            print("[validar_resultado] Error: llamada sin argumentos (%s)" % args[0])
            return

        pts = np.vstack((np.ones(50),np.arange(50))).T
        centros_true = np.array([[1,13], [1,49], [1,31], [1,0], [1,22]])
        centros = test_algoritmo(X=pts, k=5, semilla=42)

        # Validar dimensión de datos transformados.
        condicion1 = centros.shape == centros_true.shape
        fuaa_assert(condicion1,
                    mensajeFalse="La dimensión de los centros no es correcta.",
                    mensajeTrue="Dimensión de centros: resultado validado.")

        # Validar transformación.
        condicion2 = son_iguales(centros_true, centros)
        fuaa_assert(condicion2,
                    mensajeFalse="La incialización implementada no es correcta.",
                    mensajeTrue="Inicialización ++: resultado validado.")
    ###########################################################
    # Ejercicio 1. Distorsion
    ###########################################################
    elif (args[0] == "distorsion"):
        if 'funcion' in kwargs:
            test_algoritmo = kwargs['funcion']
        else:
            print( "[validar_resultado] Error: llamada sin argumentos (%s)" % args[0] )
            return
        
        distorsion_true = 1.4 
       
        distorsion = test_algoritmo(np.vstack((np.zeros(5), np.ones(5), np.ones(5)*5)).T, [2,0,1,1,0])
        
        condicion = son_iguales( distorsion_true , distorsion )
        fuaa_assert(    condicion, \
                        mensajeFalse = "El resultado no es válido.", \
                        mensajeTrue = "Resultado válido." )
     
    ###########################################################
    # Ejercicio 1. Regresión Ridge.
    ###########################################################
    elif (args[0] == "reg_ridge"):
        if 'funcion' in kwargs:
            test_algoritmo = kwargs['funcion']
        else:
            print( "[validar_resultado] Error: llamada sin argumentos (%s)" % args[0] )
            return
        
        X = np.ones((20,2))
        X [:,1] = np.arange(20)
        y = (X[:,1] > 9)*2 -1
        w_ls_true = np.array([-1.24183007,  0.13071895])
       
        w_ls = test_algoritmo( X, y, 100)
        
        condicion = son_iguales( w_ls_true , w_ls )
        fuaa_assert(    condicion, \
                        mensajeFalse = "El resultado no es válido.", \
                        mensajeTrue = "Resultado válido." )
        
    ###########################################################
    # Ejercicio 1. Error binario.
    ###########################################################
    elif (args[0] == "error_binario"):
        if 'funcion' in kwargs:
            test_algoritmo = kwargs['funcion']
        else:
            print( "[validar_resultado] Error: llamada sin argumentos (%s)" % args[0] )
            return

        y = np.array([1, 1, 1, 1, 1, -1, -1, -1, -1, -1])
        y_pred = np.array([-1, 1, 1, 1, 1, -1, -1, -1, -1, 1])
        err = test_algoritmo(y, y_pred)

        # Validar dimensión de la salida.
        condicion1 = not isinstance(err, np.ndarray)
        fuaa_assert(   condicion1, \
                    mensajeFalse = "La salida no tiene la dimensión correcta.", \
                    mensajeTrue= "Dimensión de salida: resultado validado.")

        # Validar transformación.
        condicion2 = err == 0.2
        fuaa_assert(   condicion2, \
                    mensajeFalse = "Error binario: resultado no validado.", 
                    mensajeTrue = "Error binario: resultado validado.")

    ###########################################################
    # Test.
    ###########################################################
    elif (args[0] == "test"):
        if validar_parametros(args, 4):
            condicion = args[1]
            mensajeF = args[2]
            mensajeT = args[3]
            fuaa_assert(condicion, mensajeFalse=mensajeF, mensajeTrue=mensajeT)

    ###########################################################
    # No hay ninguna opción de ejercicio.
    ###########################################################
    else:
        printcolor("Ninguna opción revisada.")

    # Cerrar el cartel.
    print("+-------------------------------------------------------------------------+")


#########################################################################
def identificar_parcial():
    username = getpass.getuser()
    hostname = socket.gethostname()
    print("Usuario %s en %s." % (username, hostname))


#########################################################################
def printcolor(mensaje, color="k"):
    """
    Función para imprimir en colores y con el formato de interés.
    """
    if (color == "r"):
        mensajeColor = "\x1b[31m" + mensaje + "\x1b[0m"
    elif (color == "g"):
        mensajeColor = "\x1b[32m" + mensaje + "\x1b[0m"
    elif (color == "y"):
        mensajeColor = "\x1b[33m" + mensaje + "\x1b[0m"
    elif (color == "b"):
        mensajeColor = "\x1b[34m" + mensaje + "\x1b[0m"
    elif (color == "p"):
        mensajeColor = "\x1b[35m" + mensaje + "\x1b[0m"
    elif (color == "c"):
        mensajeColor = "\x1b[36m" + mensaje + "\x1b[0m"
    else:
        mensajeColor = mensaje
    mensaje_out = " " + mensajeColor
    print(mensaje_out)


#########################################################################
def fuaa_assert(condicion,
                mensajeFalse="El resultado no es válido.",
                mensajeTrue="Resultado validado."):
    """
    Función similar al assert.
    """
    # Custom assert.
    if (condicion):
        printcolor(mensajeTrue, "g")
    else:
        printcolor(mensajeFalse, "r")


#########################################################################
def son_iguales(x1, x2, threshold=_THRESHOLD):
    """
    Evaluar si dos elementos son iguales o no, con una tolerancia dada (threshold).
    """
    if isinstance(x1, float) or isinstance(x1, int):
        dif = np.abs(x1 - x2)
        condicion = (dif < threshold)
    elif isinstance(x1, np.ndarray):
        dif = np.sqrt(np.sum((x1 - x2)**2)) / x1.size
        condicion = (dif < threshold)
    else:
        printcolor("Ningún tipo validado para son_iguales()", "r")
        condicion = False
    return condicion


#########################################################################
def validar_parametros(parametros, min_params):
    """
    Validar número de parámetros.
    """
    condicion = (len(parametros) >= min_params)
    if not condicion:
        printcolor("[validar_resultado] Insuficientes parámetros (\"%s\"), se necesitan %d, hay %d." %
                   (parametros[0], min_params, len(parametros)), "r")
    return condicion


#########################################################################
#def load_img(file, scale_percent=70):
#
#    img = cv2.imread(file)
#
#    scale_percent = 70 # percent of original size
#    width = int(img.shape[1] * scale_percent / 100)
#    height = int(img.shape[0] * scale_percent / 100)
#    dim = (width, height)
#
#    # resize image
#    resized = cv2.resize(img, dim, interpolation = cv2.INTER_AREA)
#    img = np.asarray(cv2.cvtColor(resized, cv2.COLOR_BGR2RGB), dtype=np.float64) / 255.
#    
#    return img
#########################################################################
def plot_colorspace(img, centros=[], elev=35, azim=-35):
    fig = plt.figure(figsize=(16,16))
    axis = fig.add_subplot(1, 1, 1, projection="3d",computed_zorder=False) # 3D plot with scalar values in each axis

    im = img[:,:]
    r, g, b = list(im[:,:,0].flatten()), list(im[:,:,1].flatten()), list(im[:,:,2].flatten())

    axis.scatter(r, g, b, facecolor=im.reshape(-1,3), marker="o",edgecolors='k',linewidth=0.02,alpha=0.3,zorder=2)
    for clust in range(len(centros)):
        axis.scatter(centros[clust,0],centros[clust,1],centros[clust,2],marker='o',s=500,facecolor=centros[clust],edgecolors='k',zorder=500)
        axis.plot(np.zeros(50)+centros[clust,0], np.linspace(1,centros[clust,1]), np.zeros(50)+centros[clust,2],c='k', linewidth=1,linestyle='--',zorder=1)
        axis.plot(np.zeros(50)+centros[clust,0], np.zeros(50)+centros[clust,1], np.linspace(0,centros[clust,2]),c='k', linewidth=1,linestyle='--',zorder=1)
    axis.set_xlabel("Red",fontsize='x-large')
    axis.set_ylabel("Green",fontsize='x-large')
    axis.set_zlabel("Blue",fontsize='x-large')
    axis.set_xlim(min(r)-0.05,max(r)+0.05)
    axis.set_ylim(min(g)-0.05,max(g)+0.05)
    axis.set_zlim(min(b)-0.05,max(b)+0.05)
    axis.view_init(elev, azim)
    plt.show()
#########################################################################
def recreate_image(codebook, labels, w, h):
    """Recreate the (compressed) image from the code book & labels"""
    return codebook[labels].reshape(w, h, -1)
#########################################################################
def plot_quantized_img(img, centros, asignaciones,algo='K-Means'):
    k = len(centros)
    plt.figure(figsize=(20,10))
    plt.axis("off")
    plt.title(f"Quantized image ({k} colors, {algo})")
    cmap_name_km = 'km'
    cmap_km = LinearSegmentedColormap.from_list(cmap_name_km, centros[np.mean(centros[:,:],axis=1).argsort()], N=k)
    plt.imshow(recreate_image(centros, asignaciones, img.shape[0], img.shape[1]),cmap=cmap_km)
    plt.colorbar(ticks=[],fraction=0.0335, pad=0.01)
    plt.show()
#########################################################################
def plot_colorspace_con_asignaciones(img, centros, asignaciones, elev=35, azim=-35, algo='K-Means'):

    fig = plt.figure(figsize=(16,16))
    axis = fig.add_subplot(1, 1, 1, projection="3d",computed_zorder=False) # 3D plot with scalar values in each axis

    im = img[:,:]
    r, g, b = list(im[:,:,0].flatten()), list(im[:,:,1].flatten()), list(im[:,:,2].flatten())

    axis.scatter(r, g, b, facecolor=centros[asignaciones], marker="o",edgecolors='k',linewidth=0.02,alpha=0.3,zorder=2)
    for clust in range(centros.shape[0]):
        axis.scatter(centros[clust,0],centros[clust,1],centros[clust,2],marker='o',s=500,facecolor=centros[clust],edgecolors='k',zorder=500)
        axis.plot(np.zeros(50)+centros[clust,0], np.linspace(1,centros[clust,1]), np.zeros(50)+centros[clust,2],c='k', linewidth=1,linestyle='--',zorder=1)
        axis.plot(np.zeros(50)+centros[clust,0], np.zeros(50)+centros[clust,1], np.linspace(0,centros[clust,2]),c='k', linewidth=1,linestyle='--',zorder=1)
    plt.title(algo,fontsize='xx-large', y=0.85)
    axis.set_xlabel("Red",fontsize='x-large')
    axis.set_ylabel("Green",fontsize='x-large')
    axis.set_zlabel("Blue",fontsize='x-large')
    axis.set_xlim(min(r)-0.05,max(r)+0.05)
    axis.set_ylim(min(g)-0.05,max(g)+0.05)
    axis.set_zlim(min(b)-0.05,max(b)+0.05)
    axis.view_init(elev,azim)
    plt.show()
#########################################################################
def plot_cuantizaciones_iniciales(img, k=3):

    k = 3

    distorsion_rand = np.zeros(36)
    distorsion_mas = np.zeros(36)

    fig11 = plt.figure(figsize=(16, 6), constrained_layout=False)
    outer_grid = fig11.add_gridspec(1, 2, wspace=0.05, hspace=0.1)
    fig11.suptitle("Cuantización dada por los clusters inciales (variando semilla)", fontsize=20)

    axs_out = outer_grid.subplots()  # Create all subplots for the inner grid.

    axs_out[0].set_title('Inicialización Aleatoria',fontsize='xx-large')
    axs_out[1].set_title('Inicialización ++',fontsize='xx-large')

    axs_out[0].set(xticks=[], yticks=[])
    axs_out[1].set(xticks=[], yticks=[])

    # gridspec inside gridspec
    inner_grid = outer_grid[0].subgridspec(6, 6, wspace=0, hspace=0)
    axs = inner_grid.subplots()  # Create all subplots for the inner grid.
    for c, ax in enumerate(axs.flatten()):
        centros, asignaciones, distancias_train = cuantizacion_con_centros_iniciales(img.reshape(-1,3), k, init='random', semilla=c+48)
        ax.imshow(recreate_image(centros, asignaciones, img.shape[0], img.shape[1]))
        ax.set(xticks=[], yticks=[])

    # gridspec inside gridspec
    inner_grid = outer_grid[1].subgridspec(6, 6, wspace=0, hspace=0)
    axs = inner_grid.subplots()  # Create all subplots for the inner grid.
    for c, ax in enumerate(axs.flatten()):
        centros, asignaciones, distancias_train = cuantizacion_con_centros_iniciales(img.reshape(-1,3), k, init='masmas', semilla=c+48)
        ax.imshow(recreate_image(centros, asignaciones, img.shape[0], img.shape[1]))
        ax.set(xticks=[], yticks=[])


    #plt.savefig('grafica_init.jpg')
    plt.show()
    
#########################################################################
def plot_optim_k(img):
    plt.figure(figsize=(18,7))

    rango_k = np.arange(2,12)
    distorsion_k = np.zeros(10)

    for k in rango_k:
        centros, asignaciones, distancias = k_means_fuaa(img.reshape(-1,3), k=k, init='random', semilla=30, verbose=False)
        plt.subplot(1,10,k-1)
        plt.title(f'k={k}',fontsize='x-large')
        plt.axis('off')
        #plt.imshow(recreate_image(centros,asignaciones.reshape(img[:,:,0].shape)[78:129,78:129].flatten(),51,51))
        plt.imshow(recreate_image(centros, asignaciones, img.shape[0], img.shape[1]))
        distorsion_k[k-2] = distorsion_fuaa(distancias,asignaciones)
    plt.show()

    plt.figure(figsize=(16,5))
    plt.plot(rango_k,distorsion_k,marker='o')
    plt.fill_between(rango_k, distorsion_k, np.zeros(10), alpha=0.2)
    plt.xticks(rango_k,fontsize='large')
    plt.yticks(fontsize='large')
    plt.xlabel('k',fontsize='x-large')
    plt.ylabel('Distorsion', fontsize='x-large')
    plt.show()
#########################################################################
